/// <reference path="./globals.d.ts" />
declare namespace Registry {
    class SoundEvent extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.SoundEventBuilder;
        create(id: string): Internal.SoundEventBuilder;
    }
    class Fluid extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.FluidBuilder;
        create(id: string, type: "tfc:spring"): Internal.HotWaterFluidBuilder;
        create(id: string): Internal.FluidBuilder;
    }
    class MobEffect extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.BasicMobEffect$Builder;
        create(id: string): Internal.BasicMobEffect$Builder;
    }
    class Block extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.BasicBlockJS$Builder;
        create(id: string, type: "detector"): Internal.DetectorBlock$Builder;
        create(id: string, type: "slab"): Internal.SlabBlockBuilder;
        create(id: string, type: "stairs"): Internal.StairBlockBuilder;
        create(id: string, type: "fence"): Internal.FenceBlockBuilder;
        create(id: string, type: "wall"): Internal.WallBlockBuilder;
        create(id: string, type: "fence_gate"): Internal.FenceGateBlockBuilder;
        create(id: string, type: "pressure_plate"): Internal.PressurePlateBlockBuilder;
        create(id: string, type: "button"): Internal.ButtonBlockBuilder;
        create(id: string, type: "falling"): Internal.FallingBlockBuilder;
        create(id: string, type: "crop"): Internal.CropBlockBuilder;
        create(id: string, type: "cardinal"): Internal.HorizontalDirectionalBlockBuilder;
        create(id: string, type: "carpet"): Internal.CarpetBlockBuilder;
        create(id: string, type: "tfc:aqueduct"): Internal.AqueductBlockBuilder;
        create(id: string, type: "tfc:loose_rock"): Internal.LooseRockBlockBuilder;
        create(id: string, type: "tfc:ground_cover"): Internal.GroundCoverBlockBuilder;
        create(id: string, type: "tfc:rock_spike"): Internal.RockSpikeBlockBuilder;
        create(id: string, type: "tfc:thin_spike"): Internal.ThinSpikeBlockBuilder;
        create(id: string, type: "tfc:moss_spreading_block"): Internal.MossSpreadingBlockBuilder;
        create(id: string, type: "tfc:moss_spreading_slab"): Internal.MossSpreadingSlabBuilder;
        create(id: string, type: "tfc:moss_spreading_stair"): Internal.MossSpreadingStairBuilder;
        create(id: string, type: "tfc:moss_spreading_wall"): Internal.MossSpreadingWallBlockBuilder;
        create(id: string, type: "tfc:moss_growing_block"): Internal.MossGrowingBlockBuilder;
        create(id: string, type: "tfc:moss_growing_slab"): Internal.MossGrowingSlabBlockBuilder;
        create(id: string, type: "tfc:moss_growing_stair"): Internal.MossGrowingStairBlockBuilder;
        create(id: string, type: "tfc:moss_growing_wall"): Internal.MossGrowingWallBlockBuilder;
        create(id: string, type: "tfc:raw_rock"): Internal.RawRockBlockBuilder;
        create(id: string, type: "tfc:lamp"): Internal.LampBlockBuilder;
        create(id: string, type: "tfc:stationary_berry_bush"): Internal.StationaryBerryBushBlockBuilder;
        create(id: string, type: "tfc:spreading_berry_bush"): Internal.SpreadingBushBlockBuilder;
        create(id: string, type: "tfc:dirt"): Internal.TFCDirtBlockBuilder;
        create(id: string, type: "tfc:crop"): Internal.DefaultCropBlockBuilder;
        create(id: string, type: "tfc:flooded_crop"): Internal.FloodedCropBlockBuilder;
        create(id: string, type: "tfc:pickable_crop"): Internal.PickableCropBlockBuilder;
        create(id: string, type: "tfc:spreading_crop"): Internal.SpreadingCropBlockBuilder;
        create(id: string, type: "tfc:double_crop"): Internal.DoubleCropBlockBuilder;
        create(id: string, type: "tfc:wild_crop"): Internal.WildCropBlockBuilder;
        create(id: string, type: "tfc:support"): Internal.SupportBlockBuilder;
        create(id: string, type: "tfc:anvil"): Internal.AnvilBlockBuilder;
        create(id: string, type: "tfc:axle"): Internal.AxleBlockBuilder;
        create(id: string, type: "tfc:encased_axle"): Internal.EncasedAxleBlockBuilder;
        create(id: string, type: "firmalife:cheese_wheel"): Internal.CheeseWheelBlockBuilder;
        create(id: string): Internal.BasicBlockJS$Builder;
    }
    class Enchantment extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.EnchantmentBuilder;
        create(id: string): Internal.EnchantmentBuilder;
    }
    class EntityType extends Internal.RegistryEventJS<any> {
    }
    class Item extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.BasicItemJS$Builder;
        create(id: string, type: "sword"): Internal.SwordItemBuilder;
        create(id: string, type: "pickaxe"): Internal.PickaxeItemBuilder;
        create(id: string, type: "axe"): Internal.AxeItemBuilder;
        create(id: string, type: "shovel"): Internal.ShovelItemBuilder;
        create(id: string, type: "shears"): Internal.ShearsItemBuilder;
        create(id: string, type: "hoe"): Internal.HoeItemBuilder;
        create(id: string, type: "helmet"): Internal.ArmorItemBuilder$Helmet;
        create(id: string, type: "chestplate"): Internal.ArmorItemBuilder$Chestplate;
        create(id: string, type: "leggings"): Internal.ArmorItemBuilder$Leggings;
        create(id: string, type: "boots"): Internal.ArmorItemBuilder$Boots;
        create(id: string, type: "music_disc"): Internal.RecordItemJS$Builder;
        create(id: string, type: "smithing_template"): Internal.SmithingTemplateItemBuilder;
        create(id: string, type: "tfc:mold"): Internal.MoldItemBuilder;
        create(id: string, type: "tfc:chisel"): Internal.ChiselItemBuilder;
        create(id: string, type: "tfc:mace"): Internal.MaceItemBuilder;
        create(id: string, type: "tfc:propick"): Internal.PropickItemBuilder;
        create(id: string, type: "tfc:scythe"): Internal.ScytheItemBuilder;
        create(id: string, type: "tfc:hoe"): Internal.TFCHoeItemBuilder;
        create(id: string, type: "tfc:javelin"): Internal.JavelinItemBuilder;
        create(id: string, type: "tfc:fluid_container"): Internal.FluidContainerItemBuilder;
        create(id: string, type: "tfc:tool"): Internal.ToolItemBuilder;
        create(id: string, type: "tfc:hammer"): Internal.HammerItemBuilder;
        create(id: string, type: "tfc:fishing_rod"): Internal.TFCFishingRodItemBuilder;
        create(id: string, type: "tfc:jar"): Internal.JarItemBuilder;
        create(id: string, type: "tfc:glassworking"): Internal.GlassworkingItemBuilder;
        create(id: string, type: "tfc:windmill_blade"): Internal.WindMillBladeItemBuilder;
        create(id: string, type: "tfc:glassworking_tool"): Internal.GlassworkingToolItemBuilder;
        create(id: string, type: "tfc:jug"): Internal.JugItemBuilder;
        create(id: string, type: "tfc:glass_bottle"): Internal.GlassBottleItemBuilder;
        create(id: string, type: "firmalife:watering_can"): Internal.WateringCanItemBuilder;
        create(id: string): Internal.BasicItemJS$Builder;
    }
    class Potion extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.PotionBuilder;
        create(id: string): Internal.PotionBuilder;
    }
    class ParticleType extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.ParticleTypeBuilder;
        create(id: string): Internal.ParticleTypeBuilder;
    }
    class BlockEntityType extends Internal.RegistryEventJS<any> {
    }
    class PaintingVariant extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.PaintingVariantBuilder;
        create(id: string): Internal.PaintingVariantBuilder;
    }
    class CustomStat extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.CustomStatBuilder;
        create(id: string): Internal.CustomStatBuilder;
    }
    class ChunkStatus extends Internal.RegistryEventJS<any> {
    }
    class RuleTest extends Internal.RegistryEventJS<any> {
    }
    class PosRuleTest extends Internal.RegistryEventJS<any> {
    }
    class Menu extends Internal.RegistryEventJS<any> {
    }
    class RecipeType extends Internal.RegistryEventJS<any> {
    }
    class RecipeSerializer extends Internal.RegistryEventJS<any> {
    }
    class Attribute extends Internal.RegistryEventJS<any> {
    }
    class GameEvent extends Internal.RegistryEventJS<any> {
    }
    class PositionSourceType extends Internal.RegistryEventJS<any> {
    }
    class StatType extends Internal.RegistryEventJS<any> {
    }
    class VillagerType extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.VillagerTypeBuilder;
        create(id: string): Internal.VillagerTypeBuilder;
    }
    class VillagerProfession extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.VillagerProfessionBuilder;
        create(id: string): Internal.VillagerProfessionBuilder;
    }
    class PointOfInterestType extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.PoiTypeBuilder;
        create(id: string): Internal.PoiTypeBuilder;
    }
    class MemoryModuleType extends Internal.RegistryEventJS<any> {
    }
    class SensorType extends Internal.RegistryEventJS<any> {
    }
    class Schedule extends Internal.RegistryEventJS<any> {
    }
    class Activity extends Internal.RegistryEventJS<any> {
    }
    class LootPoolEntryType extends Internal.RegistryEventJS<any> {
    }
    class LootFunctionType extends Internal.RegistryEventJS<any> {
    }
    class LootConditionType extends Internal.RegistryEventJS<any> {
    }
    class LootNumberProviderType extends Internal.RegistryEventJS<any> {
    }
    class LootNbtProviderType extends Internal.RegistryEventJS<any> {
    }
    class LootScoreProviderType extends Internal.RegistryEventJS<any> {
    }
    class CommandArgumentType extends Internal.RegistryEventJS<any> {
    }
    class DimensionType extends Internal.RegistryEventJS<any> {
    }
    class Dimension extends Internal.RegistryEventJS<any> {
    }
    class FloatProviderType extends Internal.RegistryEventJS<any> {
    }
    class IntProviderType extends Internal.RegistryEventJS<any> {
    }
    class HeightProviderType extends Internal.RegistryEventJS<any> {
    }
    class BlockPredicateType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenNoiseSettings extends Internal.RegistryEventJS<any> {
    }
    class WorldgenConfiguredCarver extends Internal.RegistryEventJS<any> {
    }
    class WorldgenConfiguredFeature extends Internal.RegistryEventJS<any> {
    }
    class WorldgenPlacedFeature extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructure extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructureSet extends Internal.RegistryEventJS<any> {
    }
    class WorldgenProcessorList extends Internal.RegistryEventJS<any> {
    }
    class WorldgenTemplatePool extends Internal.RegistryEventJS<any> {
    }
    class WorldgenBiome extends Internal.RegistryEventJS<any> {
    }
    class WorldgenNoise extends Internal.RegistryEventJS<any> {
    }
    class WorldgenDensityFunction extends Internal.RegistryEventJS<any> {
    }
    class WorldgenWorldPreset extends Internal.RegistryEventJS<any> {
    }
    class WorldgenFlatLevelGeneratorPreset extends Internal.RegistryEventJS<any> {
    }
    class WorldgenCarver extends Internal.RegistryEventJS<any> {
    }
    class WorldgenFeature extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructurePlacement extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructurePiece extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructureType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenPlacementModifierType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenBlockStateProviderType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenFoliagePlacerType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenTrunkPlacerType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenTreeDecoratorType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenRootPlacerType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenFeatureSizeType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenBiomeSource extends Internal.RegistryEventJS<any> {
    }
    class WorldgenChunkGenerator extends Internal.RegistryEventJS<any> {
    }
    class WorldgenMaterialCondition extends Internal.RegistryEventJS<any> {
    }
    class WorldgenMaterialRule extends Internal.RegistryEventJS<any> {
    }
    class WorldgenDensityFunctionType extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructureProcessor extends Internal.RegistryEventJS<any> {
    }
    class WorldgenStructurePoolElement extends Internal.RegistryEventJS<any> {
    }
    class ChatType extends Internal.RegistryEventJS<any> {
    }
    class CatVariant extends Internal.RegistryEventJS<any> {
    }
    class FrogVariant extends Internal.RegistryEventJS<any> {
    }
    class BannerPattern extends Internal.RegistryEventJS<any> {
    }
    class Instrument extends Internal.RegistryEventJS<any> {
    }
    class TrimMaterial extends Internal.RegistryEventJS<any> {
    }
    class TrimPattern extends Internal.RegistryEventJS<any> {
    }
    class CreativeModeTab extends Internal.RegistryEventJS<any> {
        create(id: string, type: "basic"): Internal.CreativeTabBuilder;
        create(id: string): Internal.CreativeTabBuilder;
    }
    class DamageType extends Internal.RegistryEventJS<any> {
    }
    class RuleBlockEntityModifier extends Internal.RegistryEventJS<any> {
    }
    class DecoratedPotPatterns extends Internal.RegistryEventJS<any> {
    }
    class WorldgenMultiNoiseBiomeSourceParameterList extends Internal.RegistryEventJS<any> {
    }
    class BiomeModifierSerializers extends Internal.RegistryEventJS<any> {
    }
    class DisplayContexts extends Internal.RegistryEventJS<any> {
    }
    class EntityDataSerializers extends Internal.RegistryEventJS<any> {
    }
    class FluidType extends Internal.RegistryEventJS<any> {
    }
    class GlobalLootModifierSerializers extends Internal.RegistryEventJS<any> {
    }
    class HolderSetType extends Internal.RegistryEventJS<any> {
    }
    class StructureModifierSerializers extends Internal.RegistryEventJS<any> {
    }
    class Schools extends Internal.RegistryEventJS<any> {
    }
    class Spells extends Internal.RegistryEventJS<any> {
    }
    class ModifierPredicateType extends Internal.RegistryEventJS<any> {
    }
    class ModifierType extends Internal.RegistryEventJS<any> {
    }
    class ProcessorConditionType extends Internal.RegistryEventJS<any> {
    }
    class StructureConditionType extends Internal.RegistryEventJS<any> {
    }
    class Contextual extends Internal.RegistryEventJS<any> {
    }
    class PostAction extends Internal.RegistryEventJS<any> {
    }
    class TransformerSerializer extends Internal.RegistryEventJS<any> {
    }
    class ConditionSerializer extends Internal.RegistryEventJS<any> {
    }
    class BiomeModifier extends Internal.RegistryEventJS<any> {
    }
    class SoftFluids extends Internal.RegistryEventJS<any> {
    }
    class MapMarkers extends Internal.RegistryEventJS<any> {
    }
    class WorldgenModifier extends Internal.RegistryEventJS<any> {
    }
    class StructureModifier extends Internal.RegistryEventJS<any> {
    }
}